Index: /GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlViewer.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlViewer.h	(revision 2656)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlViewer.h	(revision 2657)
@@ -13,5 +13,5 @@
 
 
-class __declspec(dllexport) QtGlViewer : public QGLWidget
+class QtGlViewer : public QGLWidget
 {
 	//Q_OBJECT
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.h	(revision 2656)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.h	(revision 2657)
@@ -49,5 +49,5 @@
 
 
-class __declspec(dllexport) QtGlRendererBuffer
+class QtGlRendererBuffer
 : public QObject, public QGLPixelBuffer, public GlRendererBuffer
 {
@@ -87,5 +87,5 @@
 
 
-class __declspec(dllexport) QtRendererControlWidget : public QWidget
+class QtRendererControlWidget : public QWidget
 {
   Q_OBJECT
@@ -170,5 +170,5 @@
 
 
-class __declspec(dllexport) QtGlRendererWidget: public QGLWidget, public GlRendererWidget
+class QtGlRendererWidget: public QGLWidget, public GlRendererWidget
 {
 	Q_OBJECT
@@ -569,5 +569,5 @@
 
 
-class __declspec(dllexport) QtGlDebuggerWidget: public QGLWidget
+class QtGlDebuggerWidget: public QGLWidget
 {
 	Q_OBJECT
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtPreprocessorThread.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtPreprocessorThread.h	(revision 2656)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtPreprocessorThread.h	(revision 2657)
@@ -11,5 +11,5 @@
 class Preprocessor;
 
-class __declspec(dllexport) QtPreprocessorThread : public PreprocessorThread, public QThread
+class QtPreprocessorThread: public PreprocessorThread, public QThread
 {
 public:
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtInterface05.vcproj
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtInterface05.vcproj	(revision 2656)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtInterface05.vcproj	(revision 2657)
@@ -103,5 +103,5 @@
 			<Tool
 				Name="VCCLCompilerTool"
-				WholeProgramOptimization="false"
+				WholeProgramOptimization="true"
 				AdditionalIncludeDirectories="..\src;..\..\src\;..\..\..\..\..\..\..\NonGTP\Zlib\include;&quot;$(QTDIR)\include\QtOpenGL&quot;;&quot;$(QTDIR)\include\Qt&quot;;&quot;$(QTDIR)\include\QtGui&quot;;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include&quot;;&quot;$(CG_INC_PATH)&quot;"
 				PreprocessorDefinitions="WIN32;NDEBUG;_LIB;GTP_INTERNAL;USE_QT;USE_VERBOSE_PVS;USE_CG"
@@ -163,8 +163,4 @@
 			<File
 				RelativePath="QtGlRenderer.cpp"
-				>
-			</File>
-			<File
-				RelativePath="QtGlRendererDll.cpp"
 				>
 			</File>
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/TestPreprocessor05.vcproj
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/TestPreprocessor05.vcproj	(revision 2656)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/TestPreprocessor05.vcproj	(revision 2657)
@@ -123,10 +123,10 @@
 				Name="VCCLCompilerTool"
 				Optimization="2"
-				InlineFunctionExpansion="2"
+				InlineFunctionExpansion="0"
 				EnableIntrinsicFunctions="false"
 				FavorSizeOrSpeed="1"
-				OmitFramePointers="true"
-				EnableFiberSafeOptimizations="true"
-				WholeProgramOptimization="false"
+				OmitFramePointers="false"
+				EnableFiberSafeOptimizations="false"
+				WholeProgramOptimization="true"
 				AdditionalIncludeDirectories="..\src;..\include;..\..\..\..\..\..\NonGTP\Boost;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;&quot;$(QTDIR)\include\QtOpenGl&quot;;&quot;$(QTDIR)\include\Qt&quot;;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include&quot;;QtInterface;..\src\sparsehash\src\;..\src\ootl\src\include\ootl;..\src\ootl\src\include\ootl\sandbox;$(NOINHERIT)"
 				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE;GTP_INTERNAL;USE_QT;USE_CG;USE_VERBOSE_PVS"
@@ -157,5 +157,5 @@
 				LinkIncremental="1"
 				AdditionalLibraryDirectories="&quot;$(QTDIR)\lib&quot;;..\src\GL;&quot;..\..\lib05\$(ConfigurationName)&quot;;..\..\..\..\..\..\NonGTP\Boost\lib;..\..\..\..\..\..\NonGTP\Xerces\xercesc\lib;..\..\..\..\..\..\NonGTP\Zlib\lib;..\..\..\..\..\..\NonGTP\Devil\lib;&quot;..\MultiLevelRayTracing\RTScene\$(ConfigurationName)&quot;;&quot;..\MultiLevelRayTracing\RTWorld\$(ConfigurationName)&quot;;&quot;QtInterface\$(ConfigurationName)&quot;;&quot;$(CG_LIB_PATH)&quot;"
-				GenerateDebugInformation="false"
+				GenerateDebugInformation="true"
 				SubSystem="1"
 				LargeAddressAware="2"
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp	(revision 2647)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp	(revision 2657)
@@ -28,6 +28,4 @@
 #include "ViewCellsManager.h"
 
-//#include "testrt.h"
-
 
 #ifdef USE_QT  
@@ -141,5 +139,5 @@
   return 0;
 #endif
-
+cout<<"hello world"<<endl;
   int returnCode = 0;
 