Index: GTP/trunk/Lib/Vis/Preprocessing/scripts/demo1.env
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/scripts/demo1.env	(revision 2643)
+++ GTP/trunk/Lib/Vis/Preprocessing/scripts/demo1.env	(revision 2660)
@@ -54,5 +54,5 @@
 	useGlDebugger false
 # 0 = INTERNAL 		1 = MLRT
-	rayCastMethod 1
+	rayCastMethod 0
 	
 #	type sampling
Index: GTP/trunk/Lib/Vis/Preprocessing/src/RayCaster.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/RayCaster.h	(revision 2629)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/RayCaster.h	(revision 2660)
@@ -187,5 +187,5 @@
 		 const int r,
 		 const int depth,
-		 float box[12]);
+		 float *box);
 
   void _SortRays2(SimpleRayContainer &rays,
Index: GTP/trunk/Lib/Vis/Preprocessing/src/Intersectable.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Intersectable.cpp	(revision 2643)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Intersectable.cpp	(revision 2660)
Index: GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp	(revision 2659)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp	(revision 2660)
@@ -630,6 +630,6 @@
 bool Preprocessor::PrepareViewCells()
 {
+#if 0
 	// load the view cells assigning the found objects to the pvss
-#if 0
 	cerr << "loading binary view cells" << endl;
 	ViewCellsManager *dummyViewCellsManager = 
@@ -668,5 +668,5 @@
 		const bool finalizeViewCells = true;
 		cout << "loading view cells from " << buf << endl;
-cout<<"here965"<<endl;
+		
 		mViewCellsManager = ViewCellsManager::LoadViewCells(buf, 
 															pvsObjects,
Index: GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.cpp	(revision 2648)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.cpp	(revision 2660)
@@ -437,5 +437,4 @@
 	{
 #if USE_TRANSFORMED_MESH_INSTANCE_HACK
-		//cerr << "here45\n****"<<endl;
 		RenderIntersectable(*dit);
 #else
Index: GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtInterface05.vcproj
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtInterface05.vcproj	(revision 2659)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtInterface05.vcproj	(revision 2660)
@@ -104,5 +104,5 @@
 				Name="VCCLCompilerTool"
 				WholeProgramOptimization="true"
-				AdditionalIncludeDirectories="..\src;..\..\src\;..\..\..\..\..\..\..\NonGTP\Zlib\include;&quot;$(QTDIR)\include\QtOpenGL&quot;;&quot;$(QTDIR)\include\Qt&quot;;&quot;$(QTDIR)\include\QtGui&quot;;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include&quot;;&quot;$(CG_INC_PATH)&quot;"
+				AdditionalIncludeDirectories="..\src;..\..\src\;..\..\..\..\..\..\..\NonGTP\Zlib\include;&quot;$(QTDIR)\include\QtOpenGL&quot;;&quot;$(QTDIR)\include\Qt&quot;;&quot;$(QTDIR)\include\QtGui&quot;;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include&quot;;&quot;$(CG_INC_PATH)&quot;;&quot;..\..\..\..\..\..\NonGTP\Xerces\xerces-c_2_8_0-x86-windows-vc_8_0\include&quot;"
 				PreprocessorDefinitions="WIN32;NDEBUG;_LIB;GTP_INTERNAL;USE_QT;USE_VERBOSE_PVS;USE_CG"
 				RuntimeLibrary="2"
Index: GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp	(revision 2659)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp	(revision 2660)
@@ -806,5 +806,5 @@
 	ViewCellsParser parser;
 	ViewCellsManager *vm = NULL;
-cout<<"780088"<<endl;
+
 	const long startTime = GetTime();
 	const bool success = parser.ParseViewCellsFile(filename, 
@@ -2435,6 +2435,4 @@
 	if (addSamplesToPvs) 
 	{
-		//if (obj->Type() == Intersectable::TRANSFORMED_MESH_INSTANCE)cout << "here12 " << endl;
-
 		hasAbsContribution = viewCell->GetPvs().AddSampleDirtyCheck(obj, ray.mPdf);
 		//hasAbsContribution = viewCell->GetPvs().AddSample(obj,ray.mPdf);
Index: GTP/trunk/Lib/Vis/Preprocessing/src/GtpVisibility05.vcproj
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/GtpVisibility05.vcproj	(revision 2659)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/GtpVisibility05.vcproj	(revision 2660)
@@ -115,5 +115,5 @@
 			<Tool
 				Name="VCCLCompilerTool"
-				AdditionalIncludeDirectories="..\src;Timer;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;..\..\..\..\..\..\NonGTP\Boost;..\src\havran;..\MultiLevelRayTracing;&quot;$(CG_INC_PATH)&quot;"
+				AdditionalIncludeDirectories="..\src;Timer;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;&quot;..\..\..\..\..\..\NonGTP\Xerces\xerces-c_2_8_0-x86-windows-vc_8_0\include&quot;;..\..\..\..\..\..\NonGTP\Boost;..\src\havran;..\MultiLevelRayTracing;&quot;$(CG_INC_PATH)&quot;"
 				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE;USE_VERBOSE_PVS;USE_QT;GTP_INTERNAL;USE_CG"
 				RuntimeLibrary="2"
Index: GTP/trunk/Lib/Vis/Preprocessing/src/TestPreprocessor05.vcproj
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/TestPreprocessor05.vcproj	(revision 2659)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/TestPreprocessor05.vcproj	(revision 2660)
@@ -129,5 +129,5 @@
 				EnableFiberSafeOptimizations="false"
 				WholeProgramOptimization="true"
-				AdditionalIncludeDirectories="..\src;..\include;..\..\..\..\..\..\NonGTP\Boost;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;&quot;$(QTDIR)\include\QtOpenGl&quot;;&quot;$(QTDIR)\include\Qt&quot;;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include&quot;;QtInterface;..\src\sparsehash\src\;..\src\ootl\src\include\ootl;..\src\ootl\src\include\ootl\sandbox;$(NOINHERIT)"
+				AdditionalIncludeDirectories="..\src;..\include;..\..\..\..\..\..\NonGTP\Boost;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;&quot;$(QTDIR)\include\QtOpenGl&quot;;&quot;$(QTDIR)\include\Qt&quot;;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include&quot;;QtInterface;..\src\sparsehash\src\;..\src\ootl\src\include\ootl;..\src\ootl\src\include\ootl\sandbox;&quot;..\..\..\..\..\..\NonGTP\Xerces\xerces-c_2_8_0-x86-windows-vc_8_0\include&quot;;$(NOINHERIT)"
 				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE;GTP_INTERNAL;USE_QT;USE_CG;USE_VERBOSE_PVS"
 				StringPooling="true"
@@ -156,5 +156,5 @@
 				OutputFile="../bin/$(ConfigurationName)/Preprocessor.exe"
 				LinkIncremental="1"
-				AdditionalLibraryDirectories="&quot;$(QTDIR)\lib&quot;;..\src\GL;&quot;..\lib05\$(ConfigurationName)&quot;;..\..\..\..\..\..\NonGTP\Boost\lib;..\..\..\..\..\..\NonGTP\Xerces\xercesc\lib;..\..\..\..\..\..\NonGTP\Zlib\lib;..\..\..\..\..\..\NonGTP\Devil\lib;&quot;..\MultiLevelRayTracing\RTScene\$(ConfigurationName)&quot;;&quot;..\MultiLevelRayTracing\RTWorld\$(ConfigurationName)&quot;;&quot;QtInterface\$(ConfigurationName)&quot;;&quot;$(CG_LIB_PATH)&quot;"
+				AdditionalLibraryDirectories="&quot;$(QTDIR)\lib&quot;;..\src\GL;&quot;..\lib05\$(ConfigurationName)&quot;;..\..\..\..\..\..\NonGTP\Boost\lib;..\..\..\..\..\..\NonGTP\Zlib\lib;..\..\..\..\..\..\NonGTP\Devil\lib;&quot;..\MultiLevelRayTracing\RTScene\$(ConfigurationName)&quot;;&quot;..\MultiLevelRayTracing\RTWorld\$(ConfigurationName)&quot;;&quot;QtInterface\$(ConfigurationName)&quot;;&quot;..\..\..\..\..\..\NonGTP\Xerces\xerces-c_2_8_0-x86-windows-vc_8_0\lib&quot;;&quot;$(CG_LIB_PATH)&quot;"
 				GenerateDebugInformation="true"
 				SubSystem="1"
Index: GTP/trunk/Lib/Vis/Preprocessing/src/RayCaster.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/RayCaster.cpp	(revision 2635)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/RayCaster.cpp	(revision 2660)
@@ -156,4 +156,5 @@
 #endif
   
+#if REMOVE_TEMP
   _SortRays(rays,
 			0,
@@ -162,4 +163,5 @@
 			b
 			);
+#endif
 }
 					
@@ -169,8 +171,8 @@
 					 const int r,
 					 const int depth,
-					 float box[12])
+					 float *box)
 {
   // pick-up a pivot
-  int axis;
+  int axis = 0;
   
   float maxDiff = -1.0f;
Index: GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp	(revision 2659)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp	(revision 2660)
@@ -220,5 +220,5 @@
 		exit(1);
 	}
-
+	
 	// export objects as obj
 	if (preprocessor->mExportObj)
@@ -244,5 +244,5 @@
 		}
 	}
-	
+
 	// parse view cells related options
 	if (!preprocessor->PrepareViewCells())
@@ -276,4 +276,5 @@
 	}
 
+
 	bool useHwGlobalLines;
 	Environment::GetSingleton()->GetBoolValue("Preprocessor.useHwGlobalLines",
@@ -298,5 +299,6 @@
 	bool evalPixelError;
 	Environment::GetSingleton()->GetBoolValue("Preprocessor.evaluatePixelError", evalPixelError);
-return 0;
+
+
 #ifdef USE_QT
 
@@ -305,6 +307,4 @@
 	pt = new QtPreprocessorThread(preprocessor);	
 	
-	//	if (preprocessor->mUseGlRenderer && (importRandomViewCells || frames))
-
 	if (evalPixelError && (importRandomViewCells || frames))
 	{
@@ -384,6 +384,6 @@
 		if (evaluatePixelError)
 		{
-		cout << "evaluating pixel error" << endl;
-		preprocessor->ComputeRenderError();
+			cout << "evaluating pixel error" << endl;
+			preprocessor->ComputeRenderError();
 		}*/
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsParser.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsParser.cpp	(revision 2659)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsParser.cpp	(revision 2660)
@@ -457,5 +457,5 @@
 void ViewCellsParseHandlers::startElement(const XMLCh* const name,
 										  AttributeList& attributes)
-{cout<<"here9978"<<endl;
+{
 	StrX lname(name);
 	string element(lname.LocalForm());
@@ -598,5 +598,5 @@
 
 void ViewCellsParseHandlers::StartViewSpaceHierarchy(AttributeList& attributes)
-{cout<<"78"<<endl;
+{
 	int len = attributes.getLength();
 
@@ -643,5 +643,5 @@
 
 void ViewCellsParseHandlers::StartObjectSpaceHierarchy(AttributeList& attributes)
-{cout<<"here45"<<endl;
+{
 	const int len = attributes.getLength();
 	Vector3 bmin, bmax;
@@ -1442,5 +1442,5 @@
 	parser->setDocumentHandler(&handler);
 	parser->setErrorHandler(&handler);
-cout<<"1178"<<endl;
+
 	unsigned long duration;
 	int errorCount = 0;