Index: GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.cpp	(revision 2665)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.cpp	(revision 2667)
@@ -158,22 +158,25 @@
 	glColorMask(GL_FALSE, GL_TRUE, GL_FALSE, GL_FALSE);
 	glColor3f(0,1,0);
-
-	glDepthFunc(GL_LESS);
-	glDepthMask(GL_TRUE);
+	glDepthFunc(GL_LESS );
 	glEnable(GL_DEPTH_TEST);
+
+	glDisable(GL_STENCIL_TEST);
+
+	pvsSize = pvs.GetSize();
+
+	Intersectable::NewMail();
+	
+	if (pvsSize == 0)
+		return 0.0f;
+
+	RenderPvs(pvs);
+
+	//glColorMask(GL_TRUE, GL_FALSE, GL_FALSE, GL_FALSE);
+	glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);
 
 	glStencilFunc(GL_EQUAL, 0x0, 0x1);
 	glStencilOp(GL_KEEP, GL_KEEP, GL_INCR); 
-
-	pvsSize = pvs.GetSize();
-	
-	if (pvsSize == 0)
-		return 0.0f;
-
-	RenderPvs(pvs);
-
-	//glColorMask(GL_TRUE, GL_FALSE, GL_FALSE, GL_FALSE);
-	glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);
 	glEnable(GL_STENCIL_TEST); 
+
 	glColor3f(1,0,0);
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/default.env
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/default.env	(revision 2647)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/default.env	(revision 2667)
@@ -7,5 +7,5 @@
 
 #filename ./data/arena-high-lods.obj
-filename ./data/vienna/vienna_cropped.obj
+#filename ./data/vienna/vienna_cropped.obj
 #filename ./data/PowerPlantM.obj
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.cpp	(revision 2665)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.cpp	(revision 2667)
@@ -1542,4 +1542,8 @@
 		float error = GetPixelError(pvsSize);
 
+
+	  //	  emit UpdatePvsErrorItem(i,
+	  //							  mPvsErrorBuffer[i]);
+	  //	  swapBuffers();
 		mPvsErrorBuffer[i].mError = error;
 		mPvsErrorBuffer[i].mPvsSize = pvsSize;
Index: GTP/trunk/Lib/Vis/Preprocessing/src/Makefile
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Makefile	(revision 2638)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Makefile	(revision 2667)
@@ -1,5 +1,5 @@
 #############################################################################
 # Makefile for building: preprocessor
-# Generated by qmake (2.00a) (Qt 4.1.2) on: st 23. I 19:46:53 2008
+# Generated by qmake (2.00a) (Qt 4.1.2) on: út 18. III 16:04:11 2008
 # Project:  preprocessor.pro
 # Template: app
@@ -63,5 +63,5 @@
 	$(MAKE) -f $(MAKEFILE).Debug uninstall
 
-Makefile: preprocessor.pro  C:/Qt/4.1.2/mkspecs/win32-msvc.net\qmake.conf C:/Qt/4.1.2/mkspecs/qconfig.pri \
+Makefile: preprocessor.pro  C:/Qt/4.1.2/mkspecs/win32-msvc2005\qmake.conf C:/Qt/4.1.2/mkspecs/qconfig.pri \
 		C:\Qt\4.1.2\mkspecs\features\qt_config.prf \
 		C:\Qt\4.1.2\mkspecs\features\exclusive_builds.prf \
Index: GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp	(revision 2664)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp	(revision 2667)
@@ -157,15 +157,15 @@
 #endif
 
-	InitTiming();
-	Debug.open("debug.log");
-
-	Environment::GetSingleton()->Parse(argc, argv, USE_EXE_PATH);
-	MeshKdTree::ParseEnvironment();
-
-	char buff[128];
-	Environment::GetSingleton()->GetStringValue("Preprocessor.type", buff);
-	string preprocessorType(buff);
-
-	if (!(preprocessor = PreprocessorFactory::CreatePreprocessor(preprocessorType)))
+  InitTiming();
+  Debug.open("debug.log");
+
+  Environment::GetSingleton()->Parse(argc, argv, USE_EXE_PATH);
+  MeshKdTree::ParseEnvironment();
+  
+  char buff[128];
+  Environment::GetSingleton()->GetStringValue("Preprocessor.type", buff);
+  string preprocessorType(buff);
+  
+  if (!(preprocessor = PreprocessorFactory::CreatePreprocessor(preprocessorType)))
 	{
 		Environment::DelSingleton();
Index: GTP/trunk/Lib/Vis/Preprocessing/src/GvsPreprocessor.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/GvsPreprocessor.cpp	(revision 2666)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/GvsPreprocessor.cpp	(revision 2667)
@@ -960,4 +960,6 @@
 
         ComputeViewCell(vc);
+		// $$ JB HACK compute just first viewcell
+		//		break;
 	}
 }
@@ -1155,7 +1157,8 @@
 	{
 		ComputeRenderError();
-		// recompute once more
+		// and second time
 		ComputeRenderError();
-
+		// and third time
+		ComputeRenderError();
 	}
 